<?php
if(!class_exists("TrafficAnalyzer")){

class TrafficAnalyzer {
		
		const DEFAULT_NO_OF_TITLES = 3; 

		public function __construct() {
		
		}		

		public  function activate() {

			global $wp_version,$wpdb;
			global $wp_roles;
			
			if(version_compare($wp_version, "3.0","<"))
				die("Traffic Analyzer requires Wordpress Version 3.0 or greater");
			
			$sql = 	" create table if not exists $wpdb->prefix"."tanalyzer_visits ( ". 
					" 	id integer primary key auto_increment, ".
					" 	ip varchar(100) , ".
					" 	script_name varchar(2000), ".
					" 	user_agent varchar(2000), ".
					"	request_uri	varchar(2000), ".
					" 	remarks text, ".
					"	browser	varchar(1000),".
					"	resource_type	varchar(100),".
					"	resource	varchar(2000),".
					" 	vtime timestamp default now(),".
					"	http_referer text " .			
					" ) ";
			$wpdb->query($sql);		// wp_tanalyzer_visits
			
			$wp_roles->add_cap("administrator","ta_settings");
			
			$wp_roles->add_cap("administrator","ta_visits");
			
			

		}

		public function loaded() {
			$str="";
			global $wp_query;
			
			$resource_type = "";
			if($wp_query->is_home){
				$resource_type="HOME";
			}else if($wp_query->is_page) {
				$resource_type="PAGE";
			}else if($wp_query->is_single){
				$resource_type="POST";
			}else if($wp_query->is_comments_popup){
				$resource_type="COMMENTS_POPUP";
			}else if($wp_query->is_comment_feed){
				$resource_type="COMMENTS_FEED";
			}else if($wp_query->is_archive){
				$resource_type="ARCHIVE";
			}else if($wp_query->is_author){
				$resource_type="AUTHOR";
			}else if($wp_query->is_post_type_archive){
				$resource_type="POST_TYPE_ARCHIVE";
			}else if ($wp_query->is_robots){
				$resource_type="ROBOTS";
			}else if ( $wp_query->is_feed){
				$resource_type="FEED";
			}else if($wp_query->is_trackback){
				$resource_type="TRACKBACK";
			}else if($wp_query->is_404){
				$resource_type="404";
			}else if($wp_query->is_category){
				$resource_type="CATEGORY";
			}else if($wp_query->is_tag){
				$resource_type="TAG";
			}else if($wp_query->is_tax){
				$resource_type="TAX";
			}else if ( $wp_query->is_search){
				$resource_type="SEARCH";
			}else if($wp_query->is_admin){
				$resource_type="ADMIN";				
			}else {
				$resource_type="OTHER";
			}
			
			$browser="";
			
			if($GLOBALS["is_IE"]){
				$browser = "InternetExplorer";
			}else if($GLOBALS["is_gecko"]){
				$browser = "Firefox";
			}else if( $GLOBALS["is_chrome"]){
				$browser = "Chrome";
			}else if($GLOBALS["is_iphone"]){
				$browser = "IPhone";
			}else if ($GLOBALS["is_lynx"]){
				$browser = "Lynx";
			}else if($GLOBALS["is_macIE"]){
				$browser = "MAC IE";
			}else if ( $GLOBALS["is_NS4"]){
				$browser = "Netscape";
			}else if ( $GLOBALS["is_opera"]){
				$browser = "Opera";
			}else if( $GLOBALS["is_safari"]) {
				$browser = "Safari";
			}else if( $GLOBALS["is_winIE"]) {
				$browser = "Windows IE";
			}else {
				$browser = "Other";
			}

			$post = $wp_query->post;

			if(isset($post))
				$resource = $post->ID;
			else 
				$resource = "";
			
			$referer = wp_get_referer();
						
			global $wpdb;
			
			$sql = " insert into $wpdb->prefix"."tanalyzer_visits ( ip, script_name, user_agent, request_uri,resource_type,browser,resource,http_referer ) values ".
					" ('".$_SERVER["REMOTE_ADDR"]."', ".
					"'".$_SERVER['SCRIPT_NAME']."', " .
					" '".$_SERVER["HTTP_USER_AGENT"]."', ".
					" '". $_SERVER['REQUEST_URI']. "', ".
					" '".$resource_type."', " .
					" '".$browser."', " .
					" '".$resource ."', " .
					" '".$referer . "'" . 
					" )";
			
			if(in_array($resource_type, array("POST","PAGE")))
				$wpdb->query($sql);			
		}		
		
		public function add_style() {		
			$css_src = plugins_url("/css",__FILE__);			
			wp_enqueue_style('ta_handle1',$css_src."/ta_main.css",null,null);
		}		
		
		public function add_script() {
			$js_src = plugins_url("/js",__FILE__);			
			wp_enqueue_script('ta_handle2',$js_src."/ta_main.js.php","jquery",null);			
		}
		
		public function add_multiselect(){
			$js_src = plugins_url("/js",__FILE__);
			$deps=array("jquery_131");	// Using the jquery bundled with this plugin. Other wise, unselect all is not working		
			
			wp_enqueue_style('ta_multiselect_css',$js_src."/jquery.multiSelect/jquery.multiSelect.css");
			
			wp_enqueue_script('jquery_131',$js_src."/daterangepicker/js"."/jquery-1.3.1.min.js");   // Uncomment this line to load jquery bundled with this plugin
			wp_enqueue_script('ta_multiselect_bgiframe_js',$js_src."/jquery.multiSelect/jquery.bgiframe.min.js",$deps);
			wp_enqueue_script('ta_multiselect_js',$js_src."/jquery.multiSelect/jquery.multiSelect.js",$deps);
		}
				
		public function add_settings_script() {
			$js_src = plugins_url("/js",__FILE__);			 
			wp_enqueue_script('ta_main_settings',$js_src."/ta_main_settings.js.php","jquery");			
		}
		
		public function add_jqgrid(){
			$js_src = plugins_url("/js",__FILE__);
			
			$deps_js=array("jquery_131","jquery-ui_1816");
			$deps_css=array("ta_jqueryui_css");
			
			wp_enqueue_style('ta_jqgrid_',$js_src."/jqgrid/css"."/ui.jqgrid.css",$deps_css);
			
			wp_enqueue_script('ta_jqgrid_lang',$js_src."/jqgrid/js/i18n"."/grid.locale-en.js",$deps_js);
			wp_enqueue_script('ta_jqgrid',$js_src."/jqgrid/js"."/jquery.jqGrid.min.js",$deps_js);		
			
			
		}
		
		public function add_daterangepicker(){
			$css_src = plugins_url("/css",__FILE__);
			$js_src = plugins_url("/js",__FILE__);			
			$ofc_src = plugins_url("",__FILE__);
					
			wp_enqueue_style('ta_daterangepicker_css',$js_src."/daterangepicker/css"."/ui.daterangepicker.css");
			wp_enqueue_style('ta_jqueryui_css',$js_src."/daterangepicker/css/redmond"."/jquery-ui-1.7.1.custom.css");
					
			
			wp_enqueue_script('jquery_131',$js_src."/daterangepicker/js"."/jquery-1.3.1.min.js");   // Uncomment this line to load jquery bundled with this plugin			
			wp_enqueue_script('jquery-ui_1816',$js_src."/daterangepicker/js"."/jquery-ui-1.8.16.custom.min.js","jquery"); // Daterangepicker is not working with its bundled jquery-ui-1.7.1.custom.min.js
						
			$deps=array("jquery_131","jquery-ui_1816");			
								
			wp_enqueue_script('ta_handle4',$js_src."/daterangepicker/js"."/daterangepicker.jQuery.js",$deps);
			wp_enqueue_script('ta_handle7',$js_src."/daterangepicker/js"."/jquery.ui.datepicker-ml.js",$deps);
			wp_enqueue_script('ta_handle8',$js_src."/daterangepicker/js"."/jquery.ui.datepicker-ar.js",$deps);
			wp_enqueue_script('ta_handle9',$js_src."/daterangepicker/js"."/jquery.ui.datepicker-es.js",$deps);
			wp_enqueue_script('ta_handle10',$js_src."/daterangepicker/js"."/jquery.ui.datepicker-fr.js",$deps);
			wp_enqueue_script('ta_handle11',$js_src."/daterangepicker/js"."/jquery.ui.datepicker-ta.js",$deps);
			wp_enqueue_script('ta_handle12',$js_src."/daterangepicker/js"."/jquery.ui.datepicker-en-GB.js",$deps);		
			wp_enqueue_script('ta_handle13',$ofc_src."/ofc/js"."/swfobject.js",$deps);
			
					
			$qry_string = "period=".$_GET['period'];
			
			if(isset($_GET['daterangepicker']) && !empty($_GET['daterangepicker']))
				$qry_string .= "&daterangepicker=".$_GET['daterangepicker'];
			
			if(isset($_GET['daterangepicker_start']) && !empty($_GET['daterangepicker_start']))
				$qry_string .= "&daterangepicker_start=".$_GET['daterangepicker_start'];
			
			if(isset($_GET['daterangepicker_end']) && !empty($_GET['daterangepicker_end']))
				$qry_string .= "&daterangepicker_end=".$_GET['daterangepicker_end'];
				
			wp_enqueue_script('ta_handle14',$ofc_src."/ofc/js"."/loader.js.php?".$qry_string,$deps);
			
						
		}		
	
	}	
}