<?php
class TA_Pie_Chart extends TA_Chart {
	
	/*
	 * Drawing the Pie Chart
	 */
	function __construct(){
		parent::__construct();	
	}
	
	function draw(){
		$data = array();
		$sdate=$this->_graph->get_start_date();
		$edate=$this->_graph->get_end_date();
		
		
				
		if(isset($sdate) && !empty($sdate))
			$data['sdate']=$sdate;
		else 
			$data['sdate']="";
			
		if(isset($edate) && !empty($edate))
			$data['edate']=$edate;
		else 
			$data['edate']="";

		$data['period'] = $this->_period;
			

		$data['period_title'] = $this->get_chart_title();
			
		$tmp = array();
		$i=0;
		$pie_bounce = new pie_bounce(10);
		$total = 0;
		$display_total=0;
		
		foreach ($this->_rows as $row){
			$total += $row[2];
		}
		
		
		foreach($this->_valid_rows as $row){			
						
			if($total!=0)
				$perc = round(($row[2]/$total)*100);
			$pie_value = new pie_value((int)$row[2],$row[1]);
			$pie_value->set_colour($this->get_color($row[3]));
			$pie_value->add_animation($pie_bounce);
			$pie_value->set_tooltip("$row[2]/$total($perc%)");
			
			
			/* Grid Data */
			$keys = array_keys($this->_display_resources,$row[1],true);			
			$data["key"] = $keys[0];
			$data["article"] = $row[1];
			$data_json = json_encode($data);
			$pie_value->on_click("show_dialog($data_json)");
			array_pop($data);
			array_pop($data);
			$data_json="";
			/* Grid Data */					
			
			$tmp[] = $pie_value;
			$i++;
			$display_total += (int) $row[2];
		}
		
		$other_total = $total - $display_total;
		if($other_total>0){
			$perc = round(($other_total/$total)*100);
			$pie_value = new pie_value((int)$other_total,"Other");
			$pie_value->set_colour("#0000ff");
			$pie_value->add_animation($pie_bounce);
			$pie_value->set_tooltip("$other_total/$total($perc%)");
			$tmp[] = $pie_value;		
		}
				
		$this->_chart->set_title($this->_title);		
		$pie = new pie();
		$pie->set_values($tmp);
		$pie->radius(180);
		$this->_chart->add_element($pie);
		echo $this->_chart->toString();	
	}
}