<?php
	$user_agent = array(
		'bot', 'yahoo', 'msn', 'spider' , 'crawl'  ,  '@' , 'ripper' , 'google', 'robot' , 'radian', 'python', '.exe' , 'alexa'
	);
	
	function ta_filter_period($period){
		$filtered_period = "";
		switch($period){
			case 'd':
				$filtered_period = 'd';
				break;
			case 'w':
				$filtered_period = 'w';
				break;
			case 'm':
				$filtered_period = 'm';
				break;	
			case 'a':
				$filtered_period = 'a';
				break;			
		}
		return $filtered_period;		
	}
	
	
	/*
	 * Date should be in yyyy/mm/dd format, else return date 01/01/1970
	 */
	function ta_filter_date($dt){
		if(!empty($dt))
			$filtered_date = date("Y/m/d",strtotime($dt));
		else 
			$filtered_date = "";
		return $filtered_date;		
	}
	
	/*
	 * In the case of jqgrid, order by field is passed from javascript
	 */
	function ta_filter_order_by_field($field){
		$filtered_field="";
		switch($field){
			case 'vtime':
				$filtered_field = "vtime";
				break;
			
		}
		return $filtered_field;
	}
	
	/*
	 * In the case of jqgrid, order  is passed from javascript
	 */
	function ta_filter_order($order){
		$filtered_order="";
		switch($order){
			case 'asc':
				$filtered_order = "asc";
				break;
			case 'desc':
				$filtered_order = "desc";
				break;			
		}
		return $filtered_order;
	}
	
	
	/*
	 * Checks whether requested is monthly or not
	 * @param string $period
	 * @return bool
	 */
	function ta_is_monthly($period){
		if($period=="m")
			return true;
		else 
			return false;
	}
	
	/*
	 * Checks whether requested is weekly or not
	 * @param string $period
	 * @return bool
	 */
	function ta_is_weekly($period){
		if($period=="w")
			return true;
		else 
			return false;
	}
		
	
	
		
	/*
	 * Function to determine the first day for the week or month corresponding to the argument date, assuming monday is the first day of the week
	 * @param string $dt , date in format "yyyy/mm/dd" 
	 * @param string $period, m for first day of month , w for first day of week
	 * @return string ,  first day of the week for the argument date
	 */	
	function ta_get_first_day($dt,$period){
		if(ta_is_monthly($period)){	// For first day of month
			$dt = substr($dt,0,4)."/".substr($dt,5,2)."/01";
		}else if(ta_is_weekly($period)){	// For first day of week		
			$ts = mktime(0,0,0,substr($dt,5,2),substr($dt,8,2),substr($dt,0,4));
			$week = date("W",$ts);
			$year = date("Y",$ts);			
			$wk_ts  = strtotime('+' . $week . ' weeks', strtotime($year . '0101'));
		   	$mon_ts = strtotime('-' . date('w', $wk_ts) + 1  . ' days', $wk_ts);	// monday timestamp	    	
		   	$dt = date('Y-m-d', $mon_ts);    	
		}
		return $dt;
	}

		/*
	 * Function to determine the last day for the week corresponding to the argument date, assuming the sunday is the last day of the week
	 * @param string $dt , date in format "yyyy/mm/dd" 
	 * @return string ,  last day of the week for the argument date
	 */	
	function ta_get_last_day($dt,$period){
		if(ta_is_weekly($period)){
			$ts = mktime(0,0,0,substr($dt,5,2),substr($dt,8,2),substr($dt,0,4));
			$week = date("W",$ts);
			$year = date("Y",$ts);			
			$wk_ts  = strtotime('+' . $week . ' weeks', strtotime($year . '0101'));
			$sun_ts =  strtotime('+' . (7 - date('w', $wk_ts) ) . ' days', $wk_ts);		// sunday timestamp ( Sunday is the last day of the week ) 
	    	$dt = date('Y-m-d',  $sun_ts );
		}else if(ta_is_monthly($period)) {
			$dt_ts = strtotime($dt);
			$last_day = date("t",$dt_ts);
			$dt = substr($dt,0,4)."/".substr($dt,5,2)."/".$last_day;			
		}
		return $dt;
	}
	
	/*
	 * Function returns First date corresponding to the arguments week and year
	 */
	function ta_week_start_date($wk_num, $yr, $first = 1, $format = 'Y/m/d'){
	    $wk_ts  = strtotime('+' . $wk_num . ' weeks', strtotime($yr . '0101'));
	    $mon_ts = strtotime('-' . date('w', $wk_ts) + $first . ' days', $wk_ts);
	    return date($format, $mon_ts);	
	}
	
	
	
	
	